/*******************************************************************/
/*  Przykladowy program obslugi klawiatury z wykorzystaniem INT 9  */
/*******************************************************************/
#include "dos.h"
#include "conio.h"
#include "stdio.h"

#define HOT_KEY  0x58      		// F12
#define EXIT_KEY 0x57      		// F11

void interrupt (*old_int_09)(void);	// wskaznik na funkcje przerwania

volatile unsigned char quit=0;		// koniec programu
volatile unsigned int  tbkl;		// stan klawiszy panelu
unsigned char stat;			// status portu klawiatury

			      /*    "1"  "2"  "3"  "4"  "5"  "6"  "7"  "8"*/
const unsigned int TBKEYS[] = { 0,0,0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,
				0,0,0,0,0,0 };

void interrupt kbd_int(void)		// przerwaniowy odbior klawiszy
{
  disable();

  if((stat=inportb(0x60)) & 0x80)	// gdy klawisz puszczany
   { stat &= 0x7F;
     tbkl &= ~TBKEYS[(stat>15)?0:stat];	// klawisze: Esc,1,2,..9,0,-,=,Bsp
   }
  else					// gdy klawisz naciskany
   {
     tbkl |=  TBKEYS[(stat>15)?0:stat];
   }

  if(stat == EXIT_KEY) quit = 1;

  /* konieczne uaktywnienie klawiatury */
  stat = inportb(0x61);
  outportb(0x61, stat | 0x80);
  outportb(0x61, stat);

  outportb(0x20, 0x20);			// End-Of-Interrupt (dla 8259)

  old_int_09();				// stara funkcja obslugi przerwania
  enable();
}

void inst_kbd(void)			// instaluj nowe przerwanie
{
  disable();
  old_int_09=getvect(0x09);
  setvect(0x09, kbd_int);
  enable();
}

void rest_kbd(void)			// przywroc stare przerwanie
{
  disable();
  setvect(0x09, *old_int_09);
  enable();
}

void main(void)
{ int c=0;

  clrscr();
  inst_kbd();
  _setcursortype(_NOCURSOR);
  gotoxy(22,24); printf("Nacisniecie ESC lub F11 konczy program");

  while(!quit)
   {
     gotoxy(1,5); printf("tbkl=%04X  klawisz=", tbkl);

     if(kbhit()) putch(c=getch());
     if(c==27) quit=1;
   }
  _setcursortype(_NORMALCURSOR);
  rest_kbd();
}
