/*******************************************************************/
/*  Przykladowy program obslugi klawiatury z wykorzystaniem INT 9  */
/*******************************************************************/
#include "dos.h"
#include "conio.h"
#include "stdio.h"

#define EXIT_KEY 0x57      // F11

/* wskaznik do oryginalnej funkcji obslugi przerwania */
void interrupt (*old_int_09)(void);

volatile unsigned char quit=0;		// koniec programu
volatile unsigned char stat;		// status portu klawiatury
volatile unsigned char znak;		// znak odczytany z portu klawiatury
volatile unsigned int  tkbd;		// stan klawiszy panelu

const unsigned int keytab[] = {
/*   */0x0000,/*ESC*/0x0000,/* 1 */0x1001,/* 2 */0x1002,/* 3 */0x1004,
/* 4 */0x1008,/* 5 */0x1010,/* 6 */0x1020,/* 7 */0x1040,/* 8 */0x1080, //  9
/* 9 */0x0000,/* 0 */0x0000,/* - */0x0000,/* = */0x0000,/* BS*/0x0000,
/*TAB*/0x0000,/* Q */0x0000,/* W */0x0000,/* E */0x0000,/* R */0x0000, // 19
/* T */0x0000,/* Y */0x0000,/* U */0x0000,/* I */0x0000,/* O */0x0000,
/* P */0x0000,/* [ */0x0000,/* ] */0x0000,/*Ent*/0x0000,/*Ctr*/0x0000, // 29
/* A */0x0000,/* S */0x0000,/* D */0x0000,/* F */0x0000,/* G */0x0000,
/* H */0x0000,/* J */0x0000,/* K */0x0000,/* L */0x0000,/* ; */0x0000, // 39
/* ' */0x0000,/* ` */0x0000,/*ShL*/0x0000,/* \ */0x0000,/* Z */0x0000,
/* X */0x0000,/* C */0x0000,/* V */0x0000,/* B */0x0000,/* N */0x0000, // 49
/* M */0x0000,/* , */0x0000,/* . */0x0000,/* / */0x0000,/*ShR*/0x0000,
/*gr**/0x0000,/*Alt*/0x0000,/*Spc*/0x0000,/*   */0x0000,/* F1*/0x0000, // 59
/* F2*/0x0000,/* F3*/0x0000,/* F4*/0x0000,/* F5*/0x0000,/* F6*/0x0000,
/* F7*/0x0000,/* F8*/0x0000,/* F9*/0x0000,/*F10*/0x0000,/*NmL*/0x0000, // 69
/*ScL*/0x0000,/*Hom*/0x0000,/* Up*/0x0000,/*PUp*/0x0000,/*gr-*/0x0000,
/* <-*/0x0000,/*gr5*/0x0000,/* ->*/0x0000,/*gr+*/0x0000,/*End*/0x0000, // 79
/* Dn*/0x0000,/*PDn*/0x0000,/*Ins*/0x0000,/*Del*/0x0000,/*   */0x0000,
/*   */0x0000,/*   */0x0000,/*F11*/0x0000,/*F12*/0x0000,/*   */0x0000, // 89
/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,
/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000, // 99
/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,
/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000, //109
/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,
/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000, //119
/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,/*   */0x0000,
/*   */0x0000,/*   */0x0000,/*   */0x0000                              //127
};
/* przerwaniowy odbior klawiszy */
void interrupt kbd_int(void)
{
  disable();

   if ((stat=inportb(0x60)) & 0x80)	// gdy klawisz puszczany
    { stat &= 0x7F;
      tkbd &= ~keytab[stat&0x7F];
    }
   else					// gdy klawisz naciskany
    {
      tkbd |= keytab[stat];
    }

  znak=stat;
  if (stat == EXIT_KEY) quit=1;

  /* konieczne uaktywnienie klawiatury */
  stat = inportb(0x61);
  outportb(0x61, stat | 0x80);
  outportb(0x61, stat);
  /* dla sterownika przerwan 8259 */
  outportb(0x20, 0x20);		// End-Of-Interrupt
  old_int_09();
  enable();
}

void inst_kbd(void)			// instaluj nowe przerwanie
{
  disable();
  old_int_09=getvect(0x09);
  setvect(0x09, kbd_int);
  enable();
}

void rest_kbd(void)			// przywroc stare przerwanie
{
  disable();
  setvect(0x09, *old_int_09);
  enable();
}

void main(void)
{ int c=' ';

  clrscr();
  inst_kbd();

  while(!quit)
   {
     gotoxy(1,6); printf("tkbd=%04X  klawisz:%3d (%c)", tkbd, znak, c);
     if(kbhit()) c=getch();
     if(c==27) quit=1;
   }
  rest_kbd();
}
